<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>問題12.2 - 2次元のランダムウォーク &mdash; 計算機実習2014</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/translations.js"></script>
    <link rel="author" title="このドキュメントについて" href="../about.html" />
    <link rel="top" title="計算機実習2014" href="../index.html" />
    <link rel="next" title="問題12-4 - 継続型ランダムウォーク" href="../12-4_history-dependent_rw/12-4.html" />
    <link rel="prev" title="問題12.1 - 離散的な時間の1次元ランダムウォーク" href="../12-1_random_walk_d1/12-1.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="../12-4_history-dependent_rw/12-4.html" title="問題12-4 - 継続型ランダムウォーク"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="../12-1_random_walk_d1/12-1.html" title="問題12.1 - 離散的な時間の1次元ランダムウォーク"
             accesskey="P">前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="label">
<span id="id1"></span><h1><a class="toc-backref" href="#id7">問題12.2 - 2次元のランダムウォーク</a><a class="headerlink" href="#label" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="contents topic" id="contents">
<p class="topic-title first">Contents</p>
<ul class="simple">
<li><a class="reference internal" href="#label" id="id7">問題12.2 - 2次元のランダムウォーク</a><ul>
<li><a class="reference internal" href="#id2" id="id8">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3" id="id9">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4" id="id10">実習課題</a></li>
<li><a class="reference internal" href="#id5" id="id11">まとめ</a></li>
<li><a class="reference internal" href="#id6" id="id12">参考文献</a></li>
</ul>
</li>
</ul>
</div>
<div class="section" id="id2">
<h2><a class="toc-backref" href="#id8">シミュレーションの目的</a><a class="headerlink" href="#id2" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>2次元格子状を互いに独立に動く多数の粒子を考える。初期状態として、正方格子の原点にランダムウォークをする粒子の集団を置いて、どの粒子も、各分割時間ごとに等しい確率で可能な4方向のいずれかにランダムに移動するとして、粒子の訪れた位置を記録する。</p>
</div>
<div class="section" id="id3">
<h2><a class="toc-backref" href="#id9">作成したプログラム</a><a class="headerlink" href="#id3" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>本シミュレーションで作成したプログラムを以下に示す。</p>
<ul class="simple">
<li>ダイアログを表示するプログラム( <a class="reference download internal" href="../_downloads/MyDialog.py"><tt class="xref download docutils literal"><span class="pre">MyDialog.py</span></tt></a> )</li>
</ul>
<p>このプログラムでは、引数として与える文字列のリストと辞書{ 文字列:コマンド}のリストから、テキストとボタンを作成し、ボタンを押すと指定したコマンドを実行するようなダイアログを表示する。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python </span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>

<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>

<span class="k">class</span> <span class="nc">Dialog</span><span class="p">():</span>

    <span class="k">def</span> <span class="nf">show_window</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">texts</span><span class="p">,</span> <span class="n">commands</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Show a dialog window.</span>
<span class="sd">        </span>
<span class="sd">        texts: A list of text in a dialog</span>
<span class="sd">        commands: A list of dictionary {&#39;name of button&#39;: command}</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span> <span class="o">=</span> <span class="n">Tk</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Dialog&#39;</span><span class="p">)</span>
        
        <span class="n">frame1</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame1</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;top&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">text</span> <span class="ow">in</span> <span class="n">texts</span><span class="p">:</span>
            <span class="n">label</span> <span class="o">=</span> <span class="n">Label</span><span class="p">(</span><span class="n">frame1</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">text</span><span class="p">)</span>
            <span class="n">label</span><span class="o">.</span><span class="n">pack</span><span class="p">()</span>
                   
        <span class="n">frame2</span> <span class="o">=</span> <span class="n">Frame</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="p">,</span> <span class="n">padx</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span> <span class="n">pady</span><span class="o">=</span><span class="mi">5</span><span class="p">)</span>
        <span class="n">frame2</span><span class="o">.</span><span class="n">pack</span><span class="p">(</span><span class="n">side</span><span class="o">=</span><span class="s">&#39;bottom&#39;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">button</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">command</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">commands</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">button</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Button</span><span class="p">(</span><span class="n">frame2</span><span class="p">,</span> <span class="n">text</span><span class="o">=</span><span class="n">command</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">],</span>
                                      <span class="n">command</span><span class="o">=</span><span class="n">command</span><span class="o">.</span><span class="n">items</span><span class="p">()[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
                                      <span class="p">)</span>
                               <span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">button</span><span class="p">[</span><span class="n">i</span><span class="p">]</span><span class="o">.</span><span class="n">grid</span><span class="p">(</span><span class="n">row</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">column</span><span class="o">=</span><span class="n">i</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">mainloop</span><span class="p">()</span>
       
    <span class="k">def</span> <span class="nf">quit</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">root</span><span class="o">.</span><span class="n">destroy</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>2次元ランダムウォークのシミュレーション( <a class="reference download internal" href="../_downloads/12-2_random_walk_d2.py"><tt class="xref download docutils literal"><span class="pre">12-2_random_walk_d2.py</span></tt></a> )</li>
</ul>
<p>2次元ランダムウォークのシミュレーションを行うプログラム。モジュールMyDialogを用いて、figureボタンを押すとnwalkers個の粒子の2次元ランダムウォークの軌跡が表示され、graphボタンを押すと<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>,<img class="math" src="../_images/math/8bf0c45d83c922fa5de6ad8f633bfc8229ce8e1e.png" alt="&lt;y(N)&gt;"/>,<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>,<img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>,<img class="math" src="../_images/math/ca7982fc2d80ddf5186c898d19a1aecc38806b7a.png" alt="&lt;\Delta R^{2}(N)&gt; = &lt;x^{2}(N)&gt; + &lt;y^{2}(N)&gt; -&lt;x(N)&gt;^{2} -&lt;y(N)&gt;^{2}"/>の値を、Nに対してプロットする。Quitボタンを押すと、プログラムを終了する。各関数の説明をすると、まず、random_walk_d2はNのリストとnwalkersの値から、xとyの配列を作成し、乱数の値の大きさに応じて次の要素の値を更新していく。こうして得られた配列を元に、calcでは<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>,<img class="math" src="../_images/math/8bf0c45d83c922fa5de6ad8f633bfc8229ce8e1e.png" alt="&lt;y(N)&gt;"/>,<img class="math" src="../_images/math/a0c186cb31dc1b737de27b78adc6702f1372d3cd.png" alt="&lt;x^{2}(N)&gt;"/>,<img class="math" src="../_images/math/5a72ebba0b7fa29a99ba24d8b53d5f96f777c867.png" alt="&lt;y^{2}(N)&gt;"/>,<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>,<img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>,<img class="math" src="../_images/math/b36e0dce845de0384ca65350c7916f17565dfadd.png" alt="&lt;\Delta R^{2}(N)&gt;"/>の値を計算する。draw_figureでは、xとyの配列のデータをそのまま用いて、2次元平面上にその軌跡をプロットする。このとき、毎回plt.plotを呼び出すのではなく、set_dataメソッドを用いて描画を行うことによって処理を軽くしている。plot_graphではcalcで計算した値を用いてそれぞれの量をNに対してプロットする。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre>  1
  2
  3
  4
  5
  6
  7
  8
  9
 10
 11
 12
 13
 14
 15
 16
 17
 18
 19
 20
 21
 22
 23
 24
 25
 26
 27
 28
 29
 30
 31
 32
 33
 34
 35
 36
 37
 38
 39
 40
 41
 42
 43
 44
 45
 46
 47
 48
 49
 50
 51
 52
 53
 54
 55
 56
 57
 58
 59
 60
 61
 62
 63
 64
 65
 66
 67
 68
 69
 70
 71
 72
 73
 74
 75
 76
 77
 78
 79
 80
 81
 82
 83
 84
 85
 86
 87
 88
 89
 90
 91
 92
 93
 94
 95
 96
 97
 98
 99
100
101
102
103
104
105
106
107
108
109
110
111</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! /usr/bin/env python</span>
<span class="c"># -*- coding:utf-8 -*-</span>
<span class="c">#</span>
<span class="c"># written by Shotaro Fujimoto, May 2014.</span>
<span class="sd">&quot;&quot;&quot; This program is the simuration of random walk in two-dimentional space.</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">matplotlib.pyplot</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">MyDialog</span> <span class="kn">import</span> <span class="n">Dialog</span>

<span class="k">def</span> <span class="nf">random_walk_d2</span><span class="p">(</span><span class="n">l</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">x0</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">y0</span><span class="o">=</span><span class="mi">0</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot; Random walk in two-dimentional space.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">global</span> <span class="n">x</span><span class="p">,</span> <span class="n">y</span>
    <span class="n">x</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)],</span> <span class="s">&#39;i&#39;</span><span class="p">)</span>
    <span class="n">y</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">zeros</span><span class="p">([</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)],</span> <span class="s">&#39;i&#39;</span><span class="p">)</span>
    <span class="n">p</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">random</span><span class="p">([</span><span class="n">nwalkers</span><span class="p">,</span> <span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>

    <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nwalkers</span><span class="p">):</span>
        <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">x0</span>
        <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span> <span class="o">=</span> <span class="n">y0</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="nb">max</span><span class="p">(</span><span class="n">N</span><span class="p">)):</span>
            <span class="k">if</span> <span class="n">p</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">&lt;</span> <span class="mf">0.25</span><span class="p">:</span>
                <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">l</span>
                <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="k">elif</span> <span class="n">p</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">&lt;</span> <span class="mf">0.5</span><span class="p">:</span>
                <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">l</span>
                <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
            <span class="k">elif</span> <span class="n">p</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">&lt;</span> <span class="mf">0.75</span><span class="p">:</span>
                <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> 
                <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">+</span> <span class="n">l</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>
                <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="p">]</span> <span class="o">=</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">][</span><span class="n">i</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">l</span>

<span class="k">def</span> <span class="nf">calc</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Caluculate the average and the variance of x(N) and y(N)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">x_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">x</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
    <span class="n">y_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">y</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
    <span class="n">x_2_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">x</span><span class="o">**</span><span class="mi">2</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
    <span class="n">y_2_ave</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">y</span><span class="o">**</span><span class="mi">2</span><span class="p">,</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">dtype</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">float32</span><span class="p">)</span><span class="o">/</span><span class="n">nwalkers</span><span class="o">*</span><span class="mf">1.</span>
    <span class="n">variance_x</span> <span class="o">=</span> <span class="n">x_2_ave</span> <span class="o">-</span> <span class="n">x_ave</span><span class="o">**</span><span class="mi">2</span>
    <span class="n">variance_y</span> <span class="o">=</span> <span class="n">y_2_ave</span> <span class="o">-</span> <span class="n">y_ave</span><span class="o">**</span><span class="mi">2</span>
    <span class="n">R_2</span> <span class="o">=</span> <span class="n">x_2_ave</span> <span class="o">+</span> <span class="n">y_2_ave</span> <span class="o">-</span> <span class="n">x_ave</span><span class="o">**</span><span class="mi">2</span> <span class="o">-</span> <span class="n">y_ave</span><span class="o">**</span><span class="mi">2</span>
    
    <span class="k">return</span> <span class="p">[</span><span class="n">x_ave</span><span class="p">,</span> <span class="n">y_ave</span><span class="p">,</span> <span class="n">variance_x</span><span class="p">,</span> <span class="n">variance_y</span><span class="p">,</span> <span class="n">R_2</span><span class="p">]</span>

<span class="k">def</span> <span class="nf">draw_figure</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Draw the figure of two-dimentional random walk.</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="s">&#39;random walk figure&#39;</span><span class="p">)</span>
    <span class="n">ax</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">111</span><span class="p">,</span> <span class="n">aspect</span><span class="o">=</span><span class="s">&#39;equal&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">grid</span><span class="p">()</span>
    <span class="n">xmin</span><span class="p">,</span> <span class="n">xmax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">amin</span><span class="p">(</span><span class="n">x</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">x</span><span class="p">)</span>
    <span class="n">ymin</span><span class="p">,</span> <span class="n">ymax</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">amin</span><span class="p">(</span><span class="n">y</span><span class="p">),</span> <span class="n">np</span><span class="o">.</span><span class="n">amax</span><span class="p">(</span><span class="n">y</span><span class="p">)</span>
    <span class="n">xmargin</span><span class="p">,</span> <span class="n">ymargin</span> <span class="o">=</span> <span class="p">(</span><span class="n">xmax</span><span class="o">-</span><span class="n">xmin</span><span class="p">)</span><span class="o">*</span><span class="mf">0.05</span><span class="p">,</span> <span class="p">(</span><span class="n">ymax</span><span class="o">-</span><span class="n">ymin</span><span class="p">)</span><span class="o">*</span><span class="mf">0.05</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="n">xmin</span><span class="o">-</span><span class="n">xmargin</span><span class="p">,</span> <span class="n">xmax</span><span class="o">+</span><span class="n">xmargin</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_ylim</span><span class="p">(</span><span class="n">ymin</span><span class="o">-</span><span class="n">ymargin</span><span class="p">,</span> <span class="n">ymax</span><span class="o">+</span><span class="n">ymargin</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s">r&#39;$x$&#39;</span><span class="p">)</span>
    <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s">r&#39;$y$&#39;</span><span class="p">)</span>
    
    <span class="k">for</span> <span class="n">n</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">nwalkers</span><span class="p">):</span>
        <span class="n">l</span><span class="p">,</span> <span class="o">=</span> <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">([],[],</span><span class="s">&#39;r-&#39;</span><span class="p">)</span>
        <span class="n">l</span><span class="o">.</span><span class="n">set_data</span><span class="p">(</span><span class="n">x</span><span class="p">[</span><span class="n">n</span><span class="p">],</span> <span class="n">y</span><span class="p">[</span><span class="n">n</span><span class="p">])</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">def</span> <span class="nf">plot_graph</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Show the graph about the average and the variance of x(N) and y(N).</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="s">&#39;random walk graph&#39;</span><span class="p">,</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">9</span><span class="p">,</span><span class="mi">8</span><span class="p">))</span>

    <span class="n">ax1</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">321</span><span class="p">)</span>
    <span class="n">ax2</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">322</span><span class="p">)</span>
    <span class="n">ax3</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">323</span><span class="p">)</span>
    <span class="n">ax4</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">324</span><span class="p">)</span>
    <span class="n">ax5</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="mi">325</span><span class="p">)</span>
    
    <span class="n">axes</span> <span class="o">=</span> <span class="p">[</span><span class="n">ax1</span><span class="p">,</span> <span class="n">ax2</span><span class="p">,</span> <span class="n">ax3</span><span class="p">,</span> <span class="n">ax4</span><span class="p">,</span> <span class="n">ax5</span><span class="p">]</span>
    <span class="n">data</span> <span class="o">=</span> <span class="n">calc</span><span class="p">()</span>
    <span class="n">labels</span> <span class="o">=</span> <span class="p">[</span><span class="s">r&#39;$&lt;x(N)&gt;$&#39;</span><span class="p">,</span> <span class="s">r&#39;$&lt;y(N)&gt;$&#39;</span><span class="p">,</span> <span class="s">r&#39;$&lt;\Delta x^{2}(N)&gt;$&#39;</span><span class="p">,</span> \
              <span class="s">r&#39;$&lt;\Delta y^{2}(N)&gt;$&#39;</span><span class="p">,</span> <span class="s">r&#39;$&lt;\Delta R^{2}(N)&gt;$&#39;</span><span class="p">]</span>
    
    <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">ax</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">axes</span><span class="p">):</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">N</span><span class="p">,</span> <span class="n">data</span><span class="p">[</span><span class="n">i</span><span class="p">])</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_xlabel</span><span class="p">(</span><span class="s">r&#39;$N$&#39;</span><span class="p">)</span>
        <span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="n">labels</span><span class="p">[</span><span class="n">i</span><span class="p">],</span> <span class="n">fontsize</span><span class="o">=</span><span class="mi">12</span><span class="p">)</span>
    
    <span class="n">fig</span><span class="o">.</span><span class="n">subplots_adjust</span><span class="p">(</span><span class="n">wspace</span><span class="o">=</span><span class="mf">0.2</span><span class="p">,</span><span class="n">hspace</span><span class="o">=</span><span class="mf">0.5</span><span class="p">)</span>
    <span class="n">fig</span><span class="o">.</span><span class="n">tight_layout</span><span class="p">()</span>   
    <span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>

<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&#39;__main__&#39;</span><span class="p">:</span>

    <span class="n">N</span> <span class="o">=</span> <span class="nb">range</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">501</span><span class="p">)</span> <span class="c"># caluculate when N = *</span>
    <span class="n">nwalkers</span> <span class="o">=</span> <span class="mi">500</span> <span class="c"># number of random walkers</span>
    
    <span class="k">def</span> <span class="nf">show_figure</span><span class="p">():</span>
        <span class="n">random_walk_d2</span><span class="p">()</span>
        <span class="n">draw_figure</span><span class="p">()</span>
    
    <span class="k">def</span> <span class="nf">graph</span><span class="p">():</span>
        <span class="n">random_walk_d2</span><span class="p">()</span>
        <span class="n">plot_graph</span><span class="p">()</span>
    
    <span class="n">window</span> <span class="o">=</span> <span class="n">Dialog</span><span class="p">()</span>
    <span class="n">window</span><span class="o">.</span><span class="n">show_window</span><span class="p">([</span><span class="s">&quot;Simulation of random walk in two-dimentional space.&quot;</span><span class="p">,</span>\
                        <span class="s">&quot;Press the button to start the simulation.&quot;</span><span class="p">],</span>\
                       <span class="p">[{</span><span class="s">&#39;figure&#39;</span><span class="p">:</span><span class="n">show_figure</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;graph&#39;</span><span class="p">:</span><span class="n">graph</span><span class="p">},</span> <span class="p">{</span><span class="s">&#39;Quit&#39;</span><span class="p">:</span><span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">}]</span>
                      <span class="p">)</span>
</pre></div>
</td></tr></table></div>
</div>
<div class="section" id="id4">
<h2><a class="toc-backref" href="#id10">実習課題</a><a class="headerlink" href="#id4" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ol class="loweralpha simple">
<li>粒子数を<img class="math" src="../_images/math/9211c6e135f6fe8e30af7e5a9624f69d57055f5a.png" alt="\mathrm{nwalkers} \geq 200"/>、各粒子のステップ数を<img class="math" src="../_images/math/4877aa0526c7392ab0659ef0c0e86f6615a05066.png" alt="N \geq 500"/>にとり、プログラムを実行せよ。各粒子が一匹の蜂を表していると考えたときに、蜂の群れの形の定性的な性質について述べよ。群れの境界の定性的な性質を<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>の関数として説明せよ。境界はギザギザしているか。それとも滑らかか。</li>
</ol>
<p>プログラム_12-2_random_walk_d2.pyを用いて2次元ランダムウォークのシミュレーションを行い(<img class="math" src="../_images/math/2c8a1bbb5c9183a8c46fdfe250c91f69f5f69997.png" alt="\mathrm{nwalkers}=500"/>)、その結果を<a class="reference internal" href="#fig-12-2-f1"><em>図1</em></a>、<a class="reference internal" href="#fig-12-2-f2"><em>図2</em></a>、<a class="reference internal" href="#fig-12-2-f3"><em>図3</em></a>に示す。これらの図を比較して分かることとして、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>の量を増大させたとき、ランダムウォークによって形作られる境界はギザギザしている。すなわち、回転半径のようなものを考えたとき、その円周の長さに比べて境界の長さがより大きくなることが分かる。また、各粒子が一匹の蜂を表していると考えたときに、蜂の群れの形は、ある時間の間の観察の結果を重ねて書くと円形に近くなっており、観察する時間を長くすると(つまりステップ数を大きくすると)、境界はギザギザしているように見える。</p>
<div class="align-center figure" id="fig-12-2-f1">
<a class="reference internal image-reference" href="../_images/figure_34.png"><img alt="../_images/figure_34.png" src="../_images/figure_34.png" style="width: 12.5cm;" /></a>
<p class="caption">2次元ランダムウォークのシミュレーション結果(N=50)</p>
</div>
<div class="align-center figure" id="fig-12-2-f2">
<a class="reference internal image-reference" href="../_images/figure_18.png"><img alt="../_images/figure_18.png" src="../_images/figure_18.png" style="width: 12.5cm;" /></a>
<p class="caption">2次元ランダムウォークのシミュレーション結果(N=500)</p>
</div>
<div class="align-center figure" id="fig-12-2-f3">
<a class="reference internal image-reference" href="../_images/figure_42.png"><img alt="../_images/figure_42.png" src="../_images/figure_42.png" style="width: 12.5cm;" /></a>
<p class="caption">2次元ランダムウォークのシミュレーション結果(N=1000)</p>
</div>
<ol class="loweralpha simple" start="2">
<li>量<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>,<img class="math" src="../_images/math/8bf0c45d83c922fa5de6ad8f633bfc8229ce8e1e.png" alt="&lt;y(N)&gt;"/>,<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>,<img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>を<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>の関数として求めよ。平均はすべての粒子について行う。また、<img class="math" src="../_images/math/ca7982fc2d80ddf5186c898d19a1aecc38806b7a.png" alt="&lt;\Delta R^{2}(N)&gt; = &lt;x^{2}(N)&gt; + &lt;y^{2}(N)&gt; -&lt;x(N)&gt;^{2} -&lt;y(N)&gt;^{2}"/>で与えられる平均2乗変位<img class="math" src="../_images/math/b36e0dce845de0384ca65350c7916f17565dfadd.png" alt="&lt;\Delta R^{2}(N)&gt;"/>を求めよ。各量の<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>依存性はどうなるか。</li>
</ol>
<p><img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>,<img class="math" src="../_images/math/8bf0c45d83c922fa5de6ad8f633bfc8229ce8e1e.png" alt="&lt;y(N)&gt;"/>,<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>,<img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>,<img class="math" src="../_images/math/b36e0dce845de0384ca65350c7916f17565dfadd.png" alt="&lt;\Delta R^{2}(N)&gt;"/>を、ステップ数Nに対してそれぞれ計算を行い(<img class="math" src="../_images/math/2c8a1bbb5c9183a8c46fdfe250c91f69f5f69997.png" alt="\mathrm{nwalkers}=500"/>)、得られた結果をグラフにまとめたものを<a class="reference internal" href="#fig-12-2-f4"><em>図4</em></a>に示した。このグラフから読み取れるように、<img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>,<img class="math" src="../_images/math/8bf0c45d83c922fa5de6ad8f633bfc8229ce8e1e.png" alt="&lt;y(N)&gt;"/>はほぼ零であり、Nの依存性はない。これは1次元の場合と同じである。また、Nが小さいところでは0に非常に近くなっているのに対して、Nが大きくなるとばらつきが生まれるのは、<a class="reference internal" href="../12-1_random_walk_d1/12-1.html#label"><em>問題12.1</em></a>で考えたように、同じ精度で求めるためにはNが大きいときには試行回数を増やす必要があったことを思い出せばよい。次に、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>, <img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>についてであるが、これらは<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に比例しており、その比例係数はおよそ<img class="math" src="../_images/math/ab6e3b19fca90304e03b80f0fcad16c58c0fc133.png" alt="1/2"/>であることが分かる。これは2次元のランダムウォークにおいて、x方向に進む確率<img class="math" src="../_images/math/f21ca347909dac4c4e0e47fc3664fef34b5cf552.png" alt="r(=1/2)"/>、右に進む確率<img class="math" src="../_images/math/5677e855d0df92fdee8f10794626ffbcef4a6ef2.png" alt="p(=1/2)"/>、左に進む確率<img class="math" src="../_images/math/3078cc7ed592eb72bebe31064b9eedc845dff472.png" alt="q(=1/2)"/>とすると</p>
<div class="math">
<p><img src="../_images/math/c59985bbfeec9aa0af9552e4497f824e1f5b7ba0.png" alt="&lt;\Delta x^{2}(N)&gt; = 4pqrl^{2}N = 4 \times \frac{1}{2} \times \frac{1}{2} \times \frac{1}{2} \times 1^{2}N = \frac{1}{2}N"/></p>
</div><p>となることと一致している。この<img class="math" src="../_images/math/2ede365ad144ab396916ec60458da03860803078.png" alt="r"/>は、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>回のステップのうち、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>が非常に大きいときには、<img class="math" src="../_images/math/eb532c7fb65b6c411d8ab63c1b74a67a9e2b77e0.png" alt="rN"/>回が<img class="math" src="../_images/math/188c175aac0a8a9c22499336711b5d7256407254.png" alt="x"/>軸方向の移動に充てられるようにみなせることと対応している。最後に<img class="math" src="../_images/math/b36e0dce845de0384ca65350c7916f17565dfadd.png" alt="&lt;\Delta R^{2}(N)&gt;"/>は、<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>と<img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>の和であるので、<img class="math" src="../_images/math/75e27f04188974063be3230dca208cd495b77ce1.png" alt="N"/>に比例して、その傾きは1である。</p>
<div class="align-center figure" id="fig-12-2-f4">
<a class="reference internal image-reference" href="../_images/figure_24.png"><img alt="../_images/figure_24.png" src="../_images/figure_24.png" style="width: 12.5cm;" /></a>
<p class="caption"><img class="math" src="../_images/math/80322654ba338c5af7d0ab4567a18a267e3a453a.png" alt="&lt;x(N)&gt;"/>,<img class="math" src="../_images/math/8bf0c45d83c922fa5de6ad8f633bfc8229ce8e1e.png" alt="&lt;y(N)&gt;"/>,<img class="math" src="../_images/math/2dc8f19cbf4d2587548d09af41991aceeab5e2b3.png" alt="&lt;\Delta x^{2}(N)&gt;"/>,<img class="math" src="../_images/math/033943670252e26b6449f2438992722f2b37dd2f.png" alt="&lt;\Delta y^{2}(N)&gt;"/>,<img class="math" src="../_images/math/b36e0dce845de0384ca65350c7916f17565dfadd.png" alt="&lt;\Delta R^{2}(N)&gt;"/>のN依存性のグラフ</p>
</div>
</div>
<div class="section" id="id5">
<h2><a class="toc-backref" href="#id11">まとめ</a><a class="headerlink" href="#id5" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>2次元の単純なランダムウォークのシミュレーションと、そこで見られるNと平均・分散・平均2乗変位について成り立つ関係について調べることができた。</p>
</div>
<div class="section" id="id6">
<h2><a class="toc-backref" href="#id12">参考文献</a><a class="headerlink" href="#id6" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li>ハーベイ・ゴールド,ジャン・トボチニク,石川正勝・宮島佐介訳『計算物理学入門』,ピアソン・エデュケーション, 2000.</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">問題12.2 - 2次元のランダムウォーク</a><ul>
<li><a class="reference internal" href="#id2">シミュレーションの目的</a></li>
<li><a class="reference internal" href="#id3">作成したプログラム</a></li>
<li><a class="reference internal" href="#id4">実習課題</a></li>
<li><a class="reference internal" href="#id5">まとめ</a></li>
<li><a class="reference internal" href="#id6">参考文献</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="../12-1_random_walk_d1/12-1.html"
                        title="前の章へ">問題12.1 - 離散的な時間の1次元ランダムウォーク</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="../12-4_history-dependent_rw/12-4.html"
                        title="次の章へ">問題12-4 - 継続型ランダムウォーク</a></p>
  <h3>このページ</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/12-2_random_walk_d2/12-2.txt"
           rel="nofollow">ソースコードを表示</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>クイック検索</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="検索" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    モジュール、クラス、または関数名を入力してください
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="../12-4_history-dependent_rw/12-4.html" title="問題12-4 - 継続型ランダムウォーク"
             >次へ</a> |</li>
        <li class="right" >
          <a href="../12-1_random_walk_d1/12-1.html" title="問題12.1 - 離散的な時間の1次元ランダムウォーク"
             >前へ</a> |</li>
        <li><a href="../index.html">計算機実習2014</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      このドキュメントは <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2 で生成しました。
    </div>
  </body>
</html>